/*
 *      imap.hpp
 *
 *      Copyright 2009 Sebastian Wankerl <far_away@online.de>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */


# ifndef IMAP_HPP
# define IMAP_HPP

# include <sstream>
# include <string>
# include <stdexcept>
# include <vector>

# include "base_io.hpp"

class imap : public base_io {
    public:
    imap (const std::string&, const std::string&, const std::string&, bool);
    virtual ~imap ();

    virtual int start ();

    private:
    virtual int recieve (int);
    virtual int procedure_string (std::string);
	virtual void find_unred_mails(std::string);
	virtual bool get_header (std::string&, unsigned);
	virtual void set_unred(int);

	std::vector<std::string> unred_mails;
	std::stringstream line;
};

# endif
